VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Dialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As LPCHOOSECOLOR) As Long
Private Declare Function SHRunDialog Lib "shell32" Alias "#61" (ByVal Hwnd As Long, ByVal hIcon As Long, ByVal sPath As String, ByVal sTitle As String, ByVal sPrompt As String, ByVal uFlags As Long) As Long
Private Declare Function SHShutDownDialog Lib "shell32" Alias "#60" (ByVal YourGuess As Long) As Long
Private Declare Function ShellAbout Lib "shell32.dll" Alias "ShellAboutA" (ByVal Hwnd As Long, ByVal szApp As String, ByVal szOtherStuff As String, ByVal hIcon As Long) As Long
Private Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal Hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
Private Declare Function ChooseFont Lib "comdlg32.dll" Alias "ChooseFontA" (lpcf As CHOOSEFONT_TYPE) As Long

Private Type LPCHOOSECOLOR
    lStructSize    As Long
    Hwnd           As Long
    hInstance      As Long
    rgbResult      As Long
    lpCustColors   As String
    Flags          As Long
    lCustData      As Long
    lpfnHook       As Long
    lpTemplateName As String
End Type

Private Type CHOOSEFONT_TYPE
    lStructSize       As Long
    hWndOwner         As Long
    hDC               As Long
    lpLogFont         As Long
    iPointSize        As Long
    Flags             As Long
    rgbColors         As Long
    lCustData         As Long
    lpfnHook          As Long
    lpTemplateName    As String
    hInstance         As Long
    lpszStyle         As String
    nFontType         As Integer
    MISSING_ALIGNMENT As Integer
    nSizeMin          As Long
    nSizeMax          As Long
End Type

Public Sub Execute(ByVal Title As String, Optional Prompt As String, _
                   Optional Icon As Long)
    
    If DLL.SYSTEM.isWindowsNT Then
        Title = StrConv(Title, vbUnicode)
        Prompt = StrConv(Prompt, vbUnicode)
    End If
    
   Call SHRunDialog(0, Icon, 0, Title, Prompt, 0)
    
End Sub
Public Sub Find(Optional Path As String = "C:\")

    Call ShellExecute(0, "find", Path, "", "C:\", 1)

End Sub
Public Sub WindowsShutDown()
    
    Call SHShutDownDialog(0)

End Sub
Public Sub About()
    
    frmAbout.Show

End Sub
Public Function AboutBox(ByVal Hwnd As Long, _
                         ByVal InfoAbout As String, Optional Copyright As String, _
                         Optional Icon As Long) As Boolean
    Dim Result As Long
    
    Result = ShellAbout(Hwnd, InfoAbout, Copyright, Icon)
    AboutBox = (Result = 1)
    
End Function
Public Function Ask(ByVal Hwnd As Long, _
                    ByVal Prompt As String, ByVal Title As String, _
                    Optional Button As VbMsgBoxStyle = vbYesNo + vbQuestion) _
                            As VbMsgBoxResult
    
    Ask = MsgBox(Hwnd, Title, Prompt, Button)

End Function
Public Function MsgBox(ByVal Hwnd As Long, _
                       ByVal Title As String, ByVal Prompt As String, _
                       ByVal Button As VbMsgBoxStyle, _
                       Optional xPos As Long = -1, Optional yPos As Long = -1, _
                       Optional AutoCloser As Long = 0) As VbMsgBoxResult
    Dim MC As New MyControls
    
    If xPos > -1 Or yPos > -1 Or AutoCloser > 0 Then Load MC
    If xPos > -1 Or yPos > -1 Then Call MC.SetMsgbox(Hwnd, xPos, yPos)
    If AutoCloser > 0 Then Call MC.SetMsgCloser(AutoCloser, App.ThreadID)
    
    MsgBox = MessageBox(Hwnd, Prompt, Title, CLng(Button))
    
    Set MC = Nothing
    
End Function
Public Function ColorDlg(ByVal Hwnd As Long, _
                         Optional ByVal ExtColors As Boolean = False) As Long
    Dim pColor As LPCHOOSECOLOR
    
    Const CC_SOLIDCOLOR = &H80
    Const CC_FULLOPEN = &H2

    ColorDlg = -1
    
    With pColor
        .lStructSize = Len(pColor)
        .Hwnd = Hwnd
        .hInstance = CLng(0)
        
        .Flags = IIf(ExtColors, CC_SOLIDCOLOR Or CC_FULLOPEN, CC_SOLIDCOLOR)
        
        .lpCustColors = STRING$(16 * 4, 0)

        If ChooseColor(pColor) Then ColorDlg = .rgbResult
    End With

End Function
Public Function FontDlg(Hwnd As Long) As StdFont
    Dim Retval As Long
    Dim TmpFName As String
    Dim F As StdFont
    
    Const SCREEN_FONTTYPE = &H2000
    Const FW_BOLD = 700
    Const CF_SCREENFONTS = &H1
    Const CF_EFFECTS = &H100
    Const CF_INITTOLOGFONTSTRUCT = &H40

    Static LFnt As LOGFONT, CF_T As CHOOSEFONT_TYPE

    On Local Error GoTo Quit

    With CF_T
        .Flags = CF_SCREENFONTS Or CF_EFFECTS Or CF_INITTOLOGFONTSTRUCT
        .hWndOwner = Hwnd
        .lStructSize = Len(CF_T)
        .lpLogFont = VarPtr(LFnt)
        .hInstance = 0
        .nFontType = SCREEN_FONTTYPE
        .rgbColors = 0
    End With
  
    If Trim$(LFnt.lfFaceName) = "" Then
        LFnt.lfFaceName = Space(31) & vbNullChar
    Else
        LFnt.lfFaceName = VBA.Left$(LFnt.lfFaceName, Len(LFnt.lfFaceName) - 1) & vbNullChar
    End If

    Retval = ChooseFont(CF_T)
  
    If Retval <> 0 Then
        TmpFName = StrConv(LFnt.lfFaceName, vbUnicode)
        
        Set F = New StdFont
        
        F.NAME = VBA.Left$(TmpFName, InStr(1, TmpFName, vbNullChar) - 1)
        F.Size = CF_T.iPointSize / 10
        F.Bold = CBool(LFnt.lfWeight >= FW_BOLD)
        F.Italic = CBool(LFnt.lfItalic)
        F.Underline = CBool(LFnt.lfUnderline)
        F.Strikethrough = CBool(LFnt.lfStrikeOut)
    End If
    
Quit:
    If Err.Number <> 0 Then Call ERROR(DIALOG, "FontDlg", Err.Number, Err.Description)
    
    Set FontDlg = F
    
    Err.Clear
    
End Function
Public Function TrayPopup(ByVal Title As String, ByVal Message As String, _
                          Optional CloseTimer As Long = 3, _
                          Optional TitleBackColor = &H8080FF, _
                          Optional TitleTextColor = vbRed, _
                          Optional TitleFont As StdFont, _
                          Optional MessageBackColor = vbBlack, _
                          Optional MessageBackColorFadeTo = -1, _
                          Optional MessageTextColor = vbYellow, _
                          Optional MessageFont As StdFont, _
                          Optional MessageAlignment As AlignmentConstants = vbLeftJustify, _
                          Optional Mail As String, _
                          Optional URL As String, _
                          Optional SideColor = vbRed, _
                          Optional Transparenz As Byte = 255, _
                          Optional PopUpSpeed As Long = 2) As Long
    Dim frm As New frmCredits
    Dim P As Long, Max As Long
        
    On Local Error GoTo Quit
    
    Load frm
    
    With frm
        Call DLL.WINDOW.StayOnTop(.Hwnd)
        Call DLL.WINDOW.Set_Transparenz(.Hwnd, Transparenz)
        
        .PupUpSpeed = PopUpSpeed
        .picBuffer.Visible = False
        
        If Mail <> "" Then
            .lblSendMail.Visible = True
            .lblSendMail.Caption = Mail
            .lblSendMail.AutoSize = True
        End If
        
        If URL <> "" Then
            .lblURL.Visible = True
            .lblURL.Caption = URL
            .lblURL.AutoSize = True
        End If
        
        If URL <> "" And Mail = "" Then .lblURL.Top = .lblSendMail.Top
        
        Max = .lblMessage.Height
        
        If Mail <> "" Then Max = .lblSendMail.Top + .lblSendMail.Height
        If URL <> "" Then Max = .lblURL.Top + .lblURL.Height
        If Max = .lblMessage.Height Then Max = 1920
        
        .lblMessage.Height = Max
        
        .lblTitle.ForeColor = TitleTextColor
        .lblIn.BackColor = TitleBackColor
        .lblMessage.ForeColor = MessageTextColor
        .BackColor = MessageBackColor

        If TitleFont Is Nothing Then
            Set TitleFont = New StdFont
        
            TitleFont.Size = 10
            TitleFont.Bold = True
        End If
        
        If MessageFont Is Nothing Then
            Set MessageFont = New StdFont
            
            MessageFont.Size = 12
            MessageFont.Bold = True
        End If
        
        Set .lblTitle.Font = TitleFont
        Set .lblMessage.Font = MessageFont

        .lblTitle.Caption = Title
        .lblTitle.Alignment = vbLeftJustify
        .lblTitle.AutoSize = True
        
        .lblIn.Height = .lblTitle.Height + 120
        
        .lblMessage.Top = .lblIn.Top + .lblIn.Height + 120
        
        If .lblTitle.Width > .lblIn.Width Then .lblIn.Width = .lblTitle.Width + 240
                
        .lblMessage.Caption = Message
        .lblMessage.Alignment = MessageAlignment
        .lblMessage.AutoSize = True
        
        Max = .lblMessage.Width
        
        If Mail <> "" Then
            If .lblSendMail.Width > Max Then Max = .lblSendMail.Width
        End If
        
        If URL <> "" Then
            If .lblURL.Width > Max Then Max = .lblURL.Width
        End If
        
        If .lblTitle.Width > Max Then Max = .lblIn.Width
        
        .lblMessage.Width = Max
        .lblSendMail.Width = Max
        .lblURL.Width = Max
        
         DoEvents
            
        .lblMessage.Left = 120
        .lblSendMail.Left = 120
        .lblURL.Left = 120
        
        Max = .lblMessage.Top + .lblMessage.Height
        
        If URL <> "" Then
            .lblURL.Top = Max + 1
            Max = .lblURL.Top + .lblURL.Height
                          
            Call DLL.NET.Create_Hyperlink(.lblURL, vbYellow, vbBlue)
        End If
                          
        If Mail <> "" Then
            .lblSendMail.Top = Max + 1
            Max = .lblSendMail.Top + .lblSendMail.Height
        
            Call DLL.NET.Create_Hyperlink(.lblSendMail, vbYellow, vbBlue)
        End If
        
        Max = Max + 120 + .Side(1).Height
        
        .Width = .lblMessage.Left + .lblMessage.Width + 120 + .Side(2).Width
        .Height = Max
            
        For P = .Side.LBound To .Side.UBound
            .Side(P).BackColor = SideColor
            
            Select Case P
                Case 0, 2: .Side(P).Top = 0
                           .Side(P).Height = .Height
                           
                           If P = 0 Then
                                .Side(P).Left = 0
                            Else
                                .Side(P).Left = .Width - .Side(P).Width
                            End If
                Case 1, 3: .Side(P).Left = 0
                           .Side(P).Width = .Width
                           
                           If P = 1 Then
                                .Side(P).Top = .Height - .Side(P).Height
                            Else
                                .Side(P).Top = 0
                            End If
            End Select
            
            .Side(P).ZOrder
        Next P
        
        .lblIn.Left = .Side(0).Left + .Side(0).Width + 60
        .lblIn.Width = .Width - .Side(2).Width - 160
        .lblTitle.Width = .lblIn.Left + .lblIn.Width - 360
        
        If MessageBackColorFadeTo > -1 Then
            Call DLL.FORMS.Fade(frm, MessageBackColor, MessageBackColorFadeTo, , cdHorizontal)
        End If

        .Top = Screen.Height
        .Left = Screen.Width - .Width
        
        .Refresh
        DoEvents
        
        If CloseTimer <= 0 Then CloseTimer = 3
        .tmrUnload = CloseTimer

        .tmrTrayScroll.Interval = 1
        .tmrTrayScroll.Enabled = True
    End With
    
    Exit Function
    
Quit:
    TrayPopup = Err.Number

    Call ERROR(DIALOG, "TrayPopup", Err.Number, Err.Description)
    
    Unload frm
    Set frm = Nothing
    
    Err.Clear
    
End Function
