VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Menu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetMenuItemID Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function DrawMenuBar Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SetMenuInfo Lib "user32" (ByVal hMenu As Long, MI As MENUINFO) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function SetMenuItemBitmaps Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal hBitmapUnchecked As Long, ByVal hBitmapChecked As Long) As Long

Private Type MENUINFO
    cbSize          As Long
    fMask           As Long
    dwStyle         As Long
    cyMax           As Long
    hbrBack         As Long
    dwContextHelpID As Long
    dwMenuData      As Long
End Type

Public Type MNUINFO
    mID      As Long
    mHwnd    As Long
    Position As Long
End Type

Public Enum MenuNFO
    mMENUBAR = 1
    mMENU = 2
    mSYSMENU = 3
End Enum

Dim FoundMenuItem As Boolean
Public Function Get_MenuHwnd(ByVal hwnd As Long) As Long
    
    Get_MenuHwnd = GetMenu(hwnd)

End Function
Public Function Get_SystemMenuHwnd(ByVal hwnd As Long) As Long
    
    Get_SystemMenuHwnd = GetSystemMenu(hwnd, False)

End Function
Public Function Get_MenuItemCount(ByVal hwnd As Long) As Long
    
    Get_MenuItemCount = GetMenuItemCountA(Get_MenuHwnd(hwnd))

End Function
Public Function Find_MenuItemByCaption(ByVal hwnd As Long, _
                                       ByVal MenuItemText As String, _
                                       Optional Systemmenu As Boolean = False) As MNUINFO
    Dim mHwnd As Long, mID2Store As Long, mHwnd2Store As Long, Pos2Store As Long
    Dim MI As MNUINFO
    
    FoundMenuItem = False
    
    mHwnd = IIf(Systemmenu, GetSystemMenu(hwnd, False), GetMenu(hwnd))
    
    Call SMenu(mHwnd, mID2Store, mHwnd2Store, Pos2Store, False, MenuItemText, hwnd)
    
    With MI
        .mHwnd = mHwnd2Store
        .Position = Pos2Store
        .mID = mID2Store
    End With
    
    Find_MenuItemByCaption = MI
    
End Function
Public Function Click_MenuItemByCaption(ByVal hwnd As Long, ByVal Caption As String) As Boolean
    Dim MI As MNUINFO
    
    MI = Find_MenuItemByCaption(hwnd, Caption)
    Click_MenuItemByCaption = Click_MenuItemByID(hwnd, MI.mID)

End Function
Public Function Click_MenuItemByID(ByVal hwnd As Long, ByVal mID As Long) As Boolean
    Click_MenuItemByID = PostMessage(hwnd, WM_COMMAND, mID, 0&)
End Function
Public Function Click_MenuItemBymHwnd(ByVal hwnd As Long, ByVal mHwnd As Long, ByVal POS As Long) As Boolean
    Click_MenuItemBymHwnd = Click_MenuItemByID(hwnd, GetMenuItemID(mHwnd, POS))
End Function
Private Function SMenu(ByVal mHwnd As Long, mID2Store As Long, mHwnd2Store As Long, POS As Long, _
                       Optional iSubFlag As Boolean, Optional CaptionToFind As String, _
                       Optional Owner As Long) As Long
    Dim n As Long, i As Long, ID As Long, Result As Long
    Dim Buffer As String
    
    On Local Error Resume Next
    
    If FoundMenuItem Then Exit Function
    
    n = GetMenuItemCountA(mHwnd)
    
    For i = 0 To n - 1
        ID = GetMenuItemID(mHwnd, i)
        
        If ID > -1 Then
            Buffer = Space$(128)
            Result = GetMenuString(mHwnd, ID, Buffer, Len(Buffer), MF_BYCOMMAND)
            Buffer = Left$(Buffer, Result)
            
            If Buffer = CaptionToFind Then mID2Store = ID: _
                                           mHwnd2Store = mHwnd: _
                                           POS = i: _
                                           FoundMenuItem = True: _
                                           Exit Function
        End If
    
        If Not iSubFlag Then
            If GetSubMenu(mHwnd, i) > 1 Then iSubFlag = True: _
                                             SMenu GetSubMenu(mHwnd, i), mID2Store, mHwnd2Store, POS, True, CaptionToFind, Owner: _
                                             iSubFlag = False
        Else
            If GetSubMenu(mHwnd, i) > 1 Then iSubFlag = True: _
                                             SMenu GetSubMenu(mHwnd, i), mID2Store, mHwnd2Store, POS, True, CaptionToFind, Owner
        End If
        
        If FoundMenuItem Then Exit Function
   Next i
    
End Function
Public Function Remove_MenuByCaption(ByVal hwnd As Long, _
                                     ByVal Caption As String, _
                                     Optional Systemmenu As Boolean = False) As Boolean
    Dim MI As MNUINFO
    
    MI = Find_MenuItemByCaption(hwnd, Caption, Systemmenu)
    
    Remove_MenuByCaption = RemoveMenuA(MI.mHwnd, MI.Position, MF_BYPOSITION)

End Function
Public Function Set_MenuColor(SetWhat As MenuNFO, ByVal hwnd As Long, _
                              ByVal Color As Long, Optional MenuIndex As Integer, _
                              Optional IncludeSubmenus As Boolean = False) As Long
    Dim MI As MENUINFO
    Dim clrref As Long, hSysMenu As Long, mHwnd As Long
        
    Const MIM_BACKGROUND = &H2
    Const MIM_APPLYTOSUBMENUS = &H80000000

    On Local Error GoTo Quit
   
    clrref = DLL.GRAFX.Convert_OLEtoRBG(Color)
   
    MI.cbSize = Len(MI)
    MI.hbrBack = CreateSolidBrush(clrref)
    
    Select Case SetWhat
        Case mMENUBAR
            MI.fMask = MIM_BACKGROUND
            Call SetMenuInfo(GetMenu(hwnd), MI)
        Case mMENU
            If MenuIndex = 0 Then _
                Set_MenuColor = Set_MenuColor(mMENUBAR, hwnd, Color): _
                Exit Function
            
            If MenuIndex < 1 Or Get_MenuItemCount(hwnd) < MenuIndex Then Exit Function
    
            MI.fMask = IIf(IncludeSubmenus, MIM_BACKGROUND Or MIM_APPLYTOSUBMENUS, MIM_BACKGROUND)
            
            mHwnd = GetMenu(hwnd)
            mHwnd = GetSubMenu(mHwnd, MenuIndex - 1)
        
            Call SetMenuInfo(mHwnd, MI)
            hwnd = mHwnd
        Case mSYSMENU
            hSysMenu = GetSystemMenu(hwnd, False)
   
            MI.fMask = MIM_BACKGROUND Or MIM_APPLYTOSUBMENUS
            
            Call SetMenuInfo(hSysMenu, MI)
            
            hwnd = hSysMenu
    End Select
    
    Call DrawMenuBar(hwnd)
    
Quit:
    Set_MenuColor = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Menu, "Set_MenuColor", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function AddPictureToMenu(ByVal hwnd As Long, _
                                 ByVal MenuText As String, _
                                 Picture As StdPicture, _
                                 Optional Systemmenu As Boolean = False) As Boolean
    Dim MI As MNUINFO
        
    On Local Error GoTo Quit
        
    MI = Find_MenuItemByCaption(hwnd, MenuText, Systemmenu)
        
    AddPictureToMenu = SetMenuItemBitmaps(MI.mHwnd, MI.Position, MF_BYPOSITION, Picture, Picture)
            
Quit:
    If Err.Number <> 0 Then Call ERROR(Menu, "AddPictureToMenu", Err.Number, Err.Description)

    Err.Clear
    
End Function
