VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Multimedia"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpStrCommand As String, ByVal lpStrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallBack As Long) As Long
Private Declare Function BeepA Lib "kernel32.dll" Alias "Beep" (ByVal dwFreq As Long, ByVal dwDuration As Long) As Long
Private Declare Function waveOutSetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long
Private Declare Function PlaySound Lib "winmm.dll" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Private Declare Function mixerOpen& Lib "winmm.dll" (phmx&, ByVal uMxId&, ByVal dwCallback&, ByVal dwInstance&, ByVal fdwOpen&)
Private Declare Function mixerGetControlDetails& Lib "winmm.dll" Alias "mixerGetControlDetailsA" (ByVal hmxobj&, pmxcd As MIXERCONTROLDETAILS, ByVal fdwDetails&)
Private Declare Function mixerSetControlDetails& Lib "winmm.dll" (ByVal hmxobj&, pmxcd As MIXERCONTROLDETAILS, ByVal fdwDetails&)
Private Declare Function mixerGetDevCaps& Lib "winmm.dll" Alias "mixerGetDevCapsA" (ByVal uMxId&, pmxcaps As MIXERCAPS, ByVal cbmxcaps&)
Private Declare Function BASSMOD_MusicLoad Lib "bassmod.dll" (ByVal mem As Integer, ByVal pfile As Any, ByVal offset As Long, ByVal Length As Long, ByVal Flags As Long) As Integer
Private Declare Function BASSMOD_Init Lib "bassmod.dll" (ByVal Device As Long, ByVal Freq As Long, ByVal Flags As Long) As Integer
Private Declare Function BASSMOD_MusicPlay Lib "bassmod.dll" () As Integer
Private Declare Function BASSMOD_MusicStop Lib "bassmod.dll" () As Integer

Private Declare Sub BASSMOD_Free Lib "bassmod.dll" ()
Private Declare Sub CopyPtrFromStruct Lib "kernel32" Alias "RtlMoveMemory" (ByVal ptr&, struct As Any, ByVal cb&)

Public Type ID3V1TAGINFO
    Songname As String
    Artist   As String
    Album    As String
    Year     As String
    Comment  As String
    Genre    As String
End Type

Public Type ID3V2TAGINFO
    Version          As String
    TagLength        As Long
    ExtendedHeader   As Boolean
    PlayCounter      As Long
    Track            As Long
    Encoder          As String
    Link             As String
    Copyright        As String
    OriginalArtist   As String
    Composer         As String
    Genre            As String
    Comment          As String
    Year             As String
    Album            As String
    Artist           As String
    Title            As String
    Language         As String
    Length           As Long
    MediaType        As String
    Publisher        As String
    DecodingSoftware As String
    UnknownFrames    As Long
End Type

Public Enum PlayCommand
    pcSTART = 1
    pcSTOP = 2
End Enum

Public Enum SYSTEMSOUND
    ssQUESTION = 0
    ssEXCLAIMATION = 1
    ssHAND = 2
    ssMAXIMIZE = 3
    ssMENUCOMMAND = 4
    ssMENUPOPUP = 5
    ssMIMIMIZE = 6
    ssMAIL = 7
    ssOPEN = 8
    ssCLOSE = 9
    ssAPPGPFAULT = 10
    ssDEFAULT = 11
    ssASTERISK = 12
    ssRESTOREUP = 13
    ssRESTOREDOWN = 14
    ssSYSTEMEXIT = 15
    ssSYSTEMSTART = 16
End Enum

Public Enum MULTIMEDIACOMMAND
    mmPLAY = 1
    mmSTOP = 0
    mmPAUSE = 2
    mmRESUME = 3
End Enum

Public Enum SPEAKERINFO
    spISENABLED = 0
    spENABLE = 1
    spDISABLE = 2
End Enum

Private Type MIXERCAPS
     wMid As Integer
     wPid As Integer
     vDriverVersion As Long
     szPname As String * 32
     fdwSupport As Long
     cDestinations As Long
End Type

Public Function Play_MultimediaFile(ByVal File As String, _
                                    Command As MULTIMEDIACOMMAND) As Boolean
    Dim oStr As String
    
    File = DLL.File.Get_ShortPath(File)
    
    Select Case Command
        Case mmSTOP
            oStr = "stop"
        Case mmPLAY, mmRESUME
            oStr = "play"
        Case mmPAUSE
            oStr = "pause"
        Case Else
            Exit Function
    End Select
    
    oStr = oStr & " " & File
    
    If mciSendString(oStr, 0&, 0, 0) = 0 Then Play_MultimediaFile = True
    
End Function
Public Sub Play_MODfile(ByVal MODfile As String, Command As PlayCommand)
    
    Static Play As Boolean
    
    Select Case Command
        Case pcSTART
            If Play Then Call Play_MODfile("", pcSTOP)
        
            Call BASSMOD_Init(-1, 44100, 0)
            Call BASSMOD_MusicLoad(0, MODfile, 0, 0, 2 Or 512)
            Call BASSMOD_MusicPlay
            
            Play = True
        Case pcSTOP
            Call BASSMOD_MusicStop
            Call BASSMOD_Free
            
            Play = False
        Case Else
            'Nope
    End Select
        
    Err.Clear

End Sub
Public Function Get_PlayTime(ByVal File As String) As Long
    Dim mssg As String * 255
        
    If Not DLL.File.Exist(File) Then
        Get_PlayTime = -1
        Exit Function
    End If
    
    File = DLL.File.Get_ShortPath(File)
    
    If mciSendString("set " & File & " time format ms", 0&, 0, 0) = 0 Then
        If mciSendString("status " & File & " length", mssg, 255, 0) = 0 Then
            Get_PlayTime = (Val(mssg) / 1000)
        End If
    End If
    
End Function
Public Function isFilePlayable(ByVal File As String) As Boolean
    Dim mssg As String * 255
        
    If Not DLL.File.Exist(File) Then Exit Function
    
    File = DLL.File.Get_ShortPath(File)

    If mciSendString("capability " & File & " can play", mssg, 255, 0) = 0 Then
        If InStr(LCase$(mssg), "true") Then
            isFilePlayable = True
        End If
    End If
    
End Function
Public Function Beep(ByVal Freq As Long, ByVal duration As Long) As Boolean
    If BeepA(Freq, duration) <> 0 Then Beep = True
End Function
Public Function Set_Volume(ByVal vRight As Integer, ByVal vLeft As Integer) As Boolean
    Dim lngVolume As Long

    lngVolume = lngVolume Or (vLeft * 2 ^ 16)
    lngVolume = lngVolume Or vRight

    Set_Volume = (waveOutSetVolume(0, lngVolume) = 0)

End Function
Public Function Play_SystemSound(Sound As SYSTEMSOUND) As Boolean
    Dim SND As String
    Dim Result As Long
    
    Const SND_ALIAS = &H10000
    Const SND_ASYNC = &H1
    Const SND_NODEFAULT = &H2

    Select Case Sound
        Case ssAPPGPFAULT:   SND = "AppGPFault"
        Case ssASTERISK:     SND = "SystemAsterisk"
        Case ssCLOSE:        SND = "Close"
        Case ssDEFAULT:      SND = ".Default"
        Case ssEXCLAIMATION: SND = "SystemExclaimation"
        Case ssHAND:         SND = "SystemHand"
        Case ssMAIL:         SND = "MailBeep"
        Case ssMAXIMIZE:     SND = "Maximize"
        Case ssMENUCOMMAND:  SND = "MenuCommand"
        Case ssMENUPOPUP:    SND = "MenuPopup"
        Case ssMIMIMIZE:     SND = "Minimize"
        Case ssOPEN:         SND = "Open"
        Case ssQUESTION:     SND = "SystemQuestion"
        Case ssRESTOREDOWN:  SND = "RestoreDown"
        Case ssRESTOREUP:    SND = "RestoreUp"
        Case ssSYSTEMEXIT:   SND = "SystemExit"
        Case ssSYSTEMSTART:  SND = "SystemStart"
        
        Case Else:           Exit Function
    End Select
    
    Result = PlaySound(SND, 0, SND_ALIAS Or SND_ASYNC Or SND_NODEFAULT)

    Play_SystemSound = (Result = 1)
    
End Function
Public Function Mute(Optional MuteON As Boolean = False) As Boolean
    Dim mON As Boolean
    Dim ControlID As Long, MaxSources As Long, hMem As Long
    Dim MCD As MIXERCONTROLDETAILS
    Dim ML As MIXERLINE
    Dim MixerState() As MIXERSETTINGS
    
    Const MIXERCONTROL_CONTROLTYPE_MUTE = &H20010002
    Const MIXER_GETCONTROLDETAILSF_VALUE = &H0&
    Const MIXER_GETLINEINFOF_DESTINATION = &H0&
    Const MIXERLINE_COMPONENTTYPE_DST_SPEAKERS = &H4&
    Const MIXER_SETCONTROLDETAILSF_VALUE = &H0&
    
    If mixerOpen(hMixer, 0, 0, 0, 0) = 0 Then
        ML.cbStruct = Len(ML)
        ML.dwDestination = 0
        
        mixerGetLineInfo hMixer, ML, MIXER_GETLINEINFOF_DESTINATION
            
        If ML.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_SPEAKERS Then
            If ML.cConnections > 10 Then
                ML.cConnections = 10
                MaxSources = 10
            Else
                MaxSources = ML.cConnections
            End If
            
            ReDim MixerState(MaxSources)

            ControlID = GetControlID(ML.dwComponentType, MIXERCONTROL_CONTROLTYPE_MUTE)
            
            If ControlID <> 0 Then
                With MCD
                    .cbDetails = 4
                    .cbStruct = Len(MCD)
                    .cChannels = ML.cChannels
                    .dwControlID = ControlID
                    .Item = 0
                    .paDetails = VarPtr(MixerState(1).MxrMute)
                End With
                  
                mixerGetControlDetails hMixer, MCD, MIXER_GETCONTROLDETAILSF_VALUE
                MixerState(1).MxrMuteID = MCD.dwControlID
                
                mON = MixerState(1).MxrMute
                
                If MuteON <> mON Then
                    MixerState(1).MxrMute = (MuteON * -1)
                                        
                    MCD.cbStruct = Len(MCD)
                    MCD.dwControlID = MixerState(1).MxrMuteID
                    MCD.cbDetails = 4
                    MCD.cChannels = 1
                    MCD.Item = 0
                    
                    hMem = GlobalAlloc(&H40, 4)
                    MCD.paDetails = GlobalLock(hMem)
                    
                    CopyPtrFromStruct MCD.paDetails, MixerState(1).MxrMute, 4
                    mixerSetControlDetails hMixer, MCD, MIXER_SETCONTROLDETAILSF_VALUE
                End If
                
                Mute = True
            End If
        End If
    End If

    GlobalUnlock hMem
    GlobalFree hMem

End Function
Public Function Soundcard_Installed() As Boolean
    Soundcard_Installed = DLL.HARDWARE.Soundcard_Installed
End Function
Public Function Soundcard_ProductName(Optional Index As Long = 0) As String
    Dim MxrCaps As MIXERCAPS
    
    If mixerGetDevCaps(Index, MxrCaps, Len(MxrCaps)) = 0 Then
        Soundcard_ProductName = Left$(MxrCaps.szPname, InStr(MxrCaps.szPname, vbNullChar) - 1)
    End If

End Function
Public Function AVI_Play(ByVal File As String, _
                         Optional Fullscreen As Boolean = False) As Boolean
    Dim Result As Long
    
    File = DLL.File.Get_ShortPath(File)

    If Fullscreen Then
        Result = mciSendString("play " & File & " fullscreen ", 0&, 0, 0&)
    Else
        Result = mciSendString("play " & File, 0&, 0, 0&)
    End If
    
    AVI_Play = (Result = 0)
    
End Function
Public Function MP3_ReadID3v1Tag(ByVal File As String, ID3Tag As ID3V1TAGINFO, _
                                 Optional ErrorNumber As Long) As Boolean
    Dim FN As Integer
    Dim ID As ID3V1TAGINFO
    Dim R$
    
    On Local Error GoTo Quit
    
    If Not DLL.File.Exist(File) Then Exit Function

    FN = FreeFile
    
    With ID
        Open File For Binary As #FN
            Get #FN, FileLen(File) - 127, R$
        
            If Not R$ = "TAG" Then
                Close #FN
                
                Exit Function
            End If
        
            Get #FN, , .Songname
            Get #FN, , .Artist
            Get #FN, , .Album
            Get #FN, , .Year
            Get #FN, , .Comment
            Get #FN, , .Genre
        Close #FN
        
        .Songname = RTrim(.Songname)
        .Artist = RTrim(.Artist)
        .Album = RTrim(.Album)
        .Year = RTrim(.Year)
        .Comment = RTrim(.Comment)
        
        R$ = ""
        R$ = RTrim(.Genre)
        .Genre = Asc(R$)
    End With
    
    ID3Tag = ID
    
    MP3_ReadID3v1Tag = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(mMedia, "MP3_ReadID3v1Tag", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function MP3_ReadID3v2Tag(ByVal File As String, ID3Tag As ID3V2TAGINFO, _
                                 Optional ErrorNumber As Long) As Boolean
    Dim Mp3FileContent As String, ID3Length As String, ID3Version As String
    Dim FrameName As String, FrameLen As String, FrameFlags As String, ID3V2Tag As String
    Dim ID3Position As Long, lngID3Length As Long, lngFrameLen As Long
    Dim FN As Integer
       
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not DLL.File.Exist(File) Then Exit Function

    FN = FreeFile
    
    Open File For Binary As #FN
        Mp3FileContent = STRING$(LOF(FN), "!")
        Get #FN, , Mp3FileContent
    Close #FN

    ID3Position = InStr(Mp3FileContent, "ID3")
    If ID3Position = 0 Then Exit Function
    
    ID3Version = mID$(Mp3FileContent, ID3Position + 3, 2)
    
    If Asc(Left$(ID3Version, 1)) <> 2 And Asc(Left$(ID3Version, 1)) <> 3 And _
       Asc(Left$(ID3Version, 1)) <> 4 Then Exit Function
    
    ID3Tag.Version = Str$(Asc(Left$(ID3Version, 1))) & "." & _
                     Trim$(Str$(Asc(Right$(ID3Version, 1))))
    
    ID3Length = mID$(Mp3FileContent, ID3Position + 6, 4)
    
    lngID3Length = &H200000 * Asc(Left$(ID3Length, 1)) + &H4000 * Asc(mID$(ID3Length, _
                   2, 1)) + &H80 * Asc(mID$(ID3Length, 3, 1)) + Asc(mID$(ID3Length, 4, 1))
    
    ID3Tag.TagLength = lngID3Length
    
    ID3V2Tag = mID$(Mp3FileContent, ID3Position, lngID3Length + 10)
    
    Mp3FileContent = ""

    If (Asc(mID$(ID3V2Tag, 6, 1)) And 32) = 32 Then
        ID3Tag.ExtendedHeader = True
        ID3V2Tag = mID$(ID3V2Tag, 10)
    End If
    
    ID3V2Tag = mID$(ID3V2Tag, 11)

    ID3Tag.UnknownFrames = 0

    Do
        If Asc(Left$(ID3Version, 1)) = 3 Or Asc(Left$(ID3Version, 1)) = 4 Then
            FrameName = Left$(ID3V2Tag, 4)
                 
            If Left$(FrameName, 3) = "3DI" Then Exit Do
                FrameLen = mID$(ID3V2Tag, 5, 4)
                lngFrameLen = 256 * 8 * 8 * Asc(Left$(FrameLen, 1)) + 256 * 8 * Asc(mID$(FrameLen, _
                                  2, 1)) + 256 * Asc(mID$(FrameLen, 3, 1)) + Asc(mID$(FrameLen, 4, 1))
            
                FrameFlags = mID$(ID3V2Tag, 9, 2)
                ID3V2Tag = mID$(ID3V2Tag, 11)
            
                Select Case FrameName
                    Case "PCNT"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.PlayCounter = Val(mID$(ID3V2Tag, 2, lngFrameLen - 1))
                        Else
                            ID3Tag.PlayCounter = Val(Left$(ID3V2Tag, lngFrameLen))
                        End If
                    Case "TRCK"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Track = Val(mID$(ID3V2Tag, 2, lngFrameLen - 1))
                        Else
                            ID3Tag.Track = Val(Left$(ID3V2Tag, lngFrameLen))
                        End If
                    Case "TENC"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Encoder = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Encoder = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "WXXX"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Link = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Link = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCOP"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Copyright = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Copyright = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TOPE"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.OriginalArtist = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.OriginalArtist = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCOM"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Composer = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Composer = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCON"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Genre = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Genre = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "COMM"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Comment = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Comment = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TYER"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Year = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Year = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TALB"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Album = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Album = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TPE1"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Artist = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Artist = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TIT2"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Title = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Title = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TLAN"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Language = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Language = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TLEN"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Length = Val(mID$(ID3V2Tag, 2, lngFrameLen - 1))
                        Else
                            ID3Tag.Length = Val(Left$(ID3V2Tag, lngFrameLen))
                        End If
                    Case "TMED"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.MediaType = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.MediaType = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TPUB"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Publisher = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Publisher = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TSSE"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.DecodingSoftware = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.DecodingSoftware = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case Else
                        ID3Tag.UnknownFrames = ID3Tag.UnknownFrames + 1
                End Select
            
                ID3V2Tag = mID$(ID3V2Tag, lngFrameLen + 1)
            ElseIf Asc(Left$(ID3Version, 1)) = 2 Then
                FrameName = Left$(ID3V2Tag, 3)
                If FrameName = "3DI" Then Exit Do
            
                FrameLen = mID$(ID3V2Tag, 4, 3)
                lngFrameLen = 256 * 8 * Asc(Left$(FrameLen, 1)) + 256 * Asc(mID$(FrameLen, 2, _
                              1)) + Asc(mID$(FrameLen, 3, 1))
            
                ID3V2Tag = mID$(ID3V2Tag, 7)
            
                Select Case FrameName
                    Case "TRK"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Track = Val(mID$(ID3V2Tag, 2, lngFrameLen - 1))
                        Else
                            ID3Tag.Track = Val(Left$(ID3V2Tag, lngFrameLen))
                        End If
                    Case "TEN"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Encoder = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Encoder = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCR"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Copyright = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Copyright = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TOA"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.OriginalArtist = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.OriginalArtist = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCM"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Composer = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Composer = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCO"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Genre = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Genre = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "COM"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Comment = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Comment = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TYE"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Year = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Year = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TAL"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Album = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Album = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TP1"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Artist = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Artist = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TT2"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Title = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Title = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TLA"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Language = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Language = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TMT"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.MediaType = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.MediaType = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TSS"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.DecodingSoftware = mID$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.DecodingSoftware = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case Else
                        ID3Tag.UnknownFrames = ID3Tag.UnknownFrames + 1
                End Select
            
                ID3V2Tag = mID$(ID3V2Tag, lngFrameLen + 1)
            End If
    Loop Until Len(ID3V2Tag) = 0
    
    MP3_ReadID3v2Tag = True

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(mMedia, "MP3_ReadID3v2Tag", Err.Number, Err.Description)
    
    Err.Clear

End Function
